searchNodes=[{"doc":"This module defines the API for a simple and distributed process name registry, using :pg . The following features are supported: Accepts any term as process names. Works distributedly. Supports registering processes with the same name as long as they are in different nodes. iex&gt; pid = self ( ) # PID &lt; 0 . 42 . 0 &gt; iex&gt; ExReg . register_name ( :foo , pid ) :yes iex&gt; ExReg . whereis_name ( :foo ) # PID &lt; 0 . 42 . 0 &gt; iex&gt; ExReg . send ( :foo , &quot;bar&quot; ) iex&gt; flush ( ) &quot;bar&quot; :ok iex&gt; ExReg . unregister_name ( :foo ) :ok iex&gt; ExReg . send ( :foo , &quot;hey&quot; ) ** (ArgumentError) Cannot send &quot;hey&quot; to :foo","ref":"ExReg.html","title":"ExReg","type":"module"},{"doc":"Generates a :via tuple for a global name .","ref":"ExReg.html#global/1","title":"ExReg.global/1","type":"function"},{"doc":"Generates a :via tuple for a local name .","ref":"ExReg.html#local/1","title":"ExReg.local/1","type":"function"},{"doc":"Registers name as an alias for a local pid globally.","ref":"ExReg.html#register_name/2","title":"ExReg.register_name/2","type":"function"},{"doc":"Sends a message to the PID associated with name .","ref":"ExReg.html#send/2","title":"ExReg.send/2","type":"function"},{"doc":"Unregisters a name .","ref":"ExReg.html#unregister_name/1","title":"ExReg.unregister_name/1","type":"function"},{"doc":"Searches for the PID associated with the name .","ref":"ExReg.html#whereis_name/1","title":"ExReg.whereis_name/1","type":"function"},{"doc":"Location.","ref":"ExReg.html#t:location/0","title":"ExReg.location/0","type":"type"},{"doc":"Process name.","ref":"ExReg.html#t:process_name/0","title":"ExReg.process_name/0","type":"type"},{"doc":"ExReg A simple process name registry using :pg : Depends on the built-in Erlang's :pg app Can be used with :via tuples for naming GenServers , Agents , etc. Accepts any valid erlang term as process names. Supports several processses with the same name as long as they are not in the same node. Always picks the node closest to the process that called the function.","ref":"readme.html","title":"ExReg","type":"extras"},{"doc":"Let's say we define the following Agent for keeping a counter: defmodule Counter do use Agent def start_link ( options \\\\ [ ] ) do Agent . start_link ( fn -&gt; 0 end , options ) end def increment ( counter ) do Agent . get_and_update ( counter , &amp; { &amp;1 , &amp;1 + 1 } ) end end We can now start it using ExReg as name registry: iex(1)&gt; name = { :via , ExReg , { &quot;metric&quot; , :my_counter } } iex(2)&gt; Counter . start_link ( name : name ) { :ok , # PID &lt; 0 . 42 . 0 &gt; } iex(3)&gt; Counter . increment ( name ) 1 iex(4)&gt; Counter . increment ( name ) 2 Distributed systems In a distributed environment, there are several things to notice: ExReg allows several processes to share the same name as long as they are not in the same Erlang node. When starting processes a process locally or sending messages exclusively to a local process: The name should match the type {:local, term()} e.g: Counter . start_link ( { :via , ExReg , { :local , { &quot;metric&quot; , :my_counter } } } ) The function ExReg.local({&quot;metric&quot;, :my_counter}) can also be used to generate the local via tuple. When sending messages to a named process, no matter its location: The name should be the term itself or {:global, term()} e.g: Counter . increment ( { :via , ExReg , { &quot;metric&quot; , :my_counter } } ) The function ExReg.global({&quot;metric&quot;, :my_counter}) can also be used to generate the global via tuple.","ref":"readme.html#small-example","title":"ExReg - Small example","type":"extras"},{"doc":"Add ExReg to your list of dependencies in mix.exs : def deps do [ { :exreg , &quot;~&gt; 1.0&quot; } ] end Requires OTP 24 or more.","ref":"readme.html#installation","title":"ExReg - Installation","type":"extras"},{"doc":"Alexander de Sousa","ref":"readme.html#author","title":"ExReg - Author","type":"extras"},{"doc":"ExReg is released under the MIT License. See the LICENSE file for further details.","ref":"readme.html#license","title":"ExReg - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Updated dependencies. Replaces :pg2 with :pg so it works with OTP 24. Uses a scoped :pg process to avoid clashing with other :pg uses.","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"Enhancements Updated dependencies. Now supports several processes with the same name as long as they are not in the same node. Added formatter.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]